/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of Skein.xs. Do not edit this file, edit Skein.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Skein.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include "Optimized_64bit/SHA3api_ref.h"
#include "Optimized_64bit/skein.h"

typedef Skein_256_Ctxt_t  * Digest__Skein__256;
typedef Skein_512_Ctxt_t  * Digest__Skein__512;
typedef Skein1024_Ctxt_t  * Digest__Skein__1024;

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 28 "Skein.c"

XS(XS_Digest__Skein_Skein); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein_Skein)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::Skein", "hashbitlen, data");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	hashbitlen = (int)SvIV(ST(0));
	const BitSequence *	data = (const BitSequence *)SvPV_nolen(ST(1));
	char *	RETVAL;
	dXSTARG;
#line 23 "Skein.xs"
		if (hashbitlen < 0)
			croak("hashbitlen < 0");
	{
		BitSequence     hashval[128];
		char ret[256 + 1];
		int i;
		if ( Hash( hashbitlen, data, (DataLength) SvCUR(ST(1)) * 8, hashval ) != SUCCESS )
			croak("Hash() failed");
		for (i=0; i<hashbitlen/8; i++)
			sprintf(&ret[2*i], "%02X", hashval[i]);
		ST(0) = sv_2mortal(newSVpv(ret, hashbitlen/4));
		XSRETURN(1);
	}
#line 62 "Skein.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__Skein_skein_256); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein_skein_256)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::skein_256", "data");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const BitSequence *	data = (const BitSequence *)SvPV_nolen(ST(0));
	char *	RETVAL;
	dXSTARG;
#line 41 "Skein.xs"
	{
		BitSequence hashval[256/8];
		if ( Hash( 256, data, (DataLength) SvCUR(ST(0)) * 8, hashval ) != SUCCESS )
			croak("Hash(256) failed");
		ST(0) = sv_2mortal(newSVpv(hashval, 256/8));
		XSRETURN(1);
	}
#line 94 "Skein.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__Skein_skein_512); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein_skein_512)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::skein_512", "data");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const BitSequence *	data = (const BitSequence *)SvPV_nolen(ST(0));
	char *	RETVAL;
	dXSTARG;
#line 53 "Skein.xs"
	{
		char hashval[512/8];
		if ( Hash( 512, data, (DataLength) SvCUR(ST(0)) * 8, hashval ) != SUCCESS )
			croak("Hash(512) failed");
		ST(0) = sv_2mortal(newSVpv(hashval, 512/8));
		XSRETURN(1);
	}
#line 126 "Skein.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__Skein_skein_1024); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein_skein_1024)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::skein_1024", "data");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const BitSequence *	data = (const BitSequence *)SvPV_nolen(ST(0));
	char *	RETVAL;
	dXSTARG;
#line 65 "Skein.xs"
	{
		char hashval[1024/8];
		if ( Hash( 1024, data, (DataLength) SvCUR(ST(0)) * 8, hashval ) != SUCCESS )
			croak("Hash(1024) failed");
		ST(0) = sv_2mortal(newSVpv(hashval, 1024/8));
		XSRETURN(1);
	}
#line 158 "Skein.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__Skein__256_clone); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__256_clone)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::256::clone", "ctx");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Digest__Skein__256	ctx;
#line 80 "Skein.xs"
		Skein_256_Ctxt_t *dest;
#line 180 "Skein.c"
	Digest__Skein__256	RETVAL;

	if (sv_derived_from(ST(0), "Digest::Skein::256")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__256,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::256::clone",
			"ctx", "Digest::Skein::256");
#line 82 "Skein.xs"
		Newx(dest, 1, Skein_256_Ctxt_t);
		memcpy(dest, ctx, sizeof(*dest));
		RETVAL = dest;
#line 195 "Skein.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Digest::Skein::256", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Digest__Skein__256_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__256_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::256::new", "package, hashbitlen=256");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	package = ST(0);
	int	hashbitlen;
	Digest__Skein__256	RETVAL;

	if (items < 2)
	    hashbitlen = 256;
	else {
	    hashbitlen = (int)SvIV(ST(1));
	}
#line 93 "Skein.xs"
		if (hashbitlen > 256)
			croak("hashbitlen > 256");
		if (SvROK(package)) {	/* called as $digest->new or $digest->reset */
			IV tmp;
			Digest__Skein__256	ctx;
			if (! sv_derived_from(package, "Digest::Skein::256"))
				croak("meh.");
			tmp = SvIV((SV*)SvRV(package));
			ctx = INT2PTR(Digest__Skein__256, tmp);
			if ( Skein_256_Init( ctx, items==2 ? hashbitlen : ctx->h.hashBitLen ) != SUCCESS )
				croak("Init() failed");
			RETVAL = ctx;
		}
		else {
			Skein_256_Ctxt_t *ctx;
			Newx(ctx, 1, Skein_256_Ctxt_t);
			if ( Skein_256_Init(ctx, hashbitlen) != SUCCESS )
				croak("Init() failed");
			ST(0) = sv_newmortal();
			sv_setref_pv(ST(0), "Digest::Skein::256", (void*)ctx);
		}
		XSRETURN(1);
#line 249 "Skein.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__Skein__256_hashbitlen); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__256_hashbitlen)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::256::hashbitlen", "ctx");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Digest__Skein__256	ctx;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Digest::Skein::256")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__256,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::256::hashbitlen",
			"ctx", "Digest::Skein::256");
#line 120 "Skein.xs"
		RETVAL = ctx->h.hashBitLen;
#line 282 "Skein.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Digest__Skein__256_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__256_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::256::DESTROY", "ctx");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Digest__Skein__256	ctx;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__256,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Digest::Skein::256::DESTROY",
			"ctx");
#line 128 "Skein.xs"
		Safefree(ctx);
#line 313 "Skein.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Digest__Skein__256_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__256_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::256::add", "ctx, data, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Digest__Skein__256	ctx;
	const u08b_t *	data;
	Digest__Skein__256	RETVAL;

	if (sv_derived_from(ST(0), "Digest::Skein::256")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__256,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::256::add",
			"ctx", "Digest::Skein::256");
#line 135 "Skein.xs"
	{
		int i;
		for (i=1; i<items; i++)
			if ( Skein_256_Update(ctx, (const u08b_t *)SvPV_nolen(ST(i)), SvCUR(ST(i))) != SUCCESS )
				croak("Update() failed");
		RETVAL = ctx;
	}
#line 351 "Skein.c"
    }
    XSRETURN(1);
}


XS(XS_Digest__Skein__256_digest); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__256_digest)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::256::digest", "ctx");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Digest__Skein__256	ctx;
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Digest::Skein::256")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__256,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::256::digest",
			"ctx", "Digest::Skein::256");
#line 147 "Skein.xs"
	{
		char hashval[256/8];
		int len = (ctx->h.hashBitLen + 7) >> 3;
		if ( Skein_256_Final(ctx, hashval) != SUCCESS )
			croak("final() failed");
		ST(0) = sv_2mortal(newSVpv(hashval, len));
		XSRETURN(1);
	}
#line 392 "Skein.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__Skein__512_clone); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__512_clone)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::512::clone", "ctx");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Digest__Skein__512	ctx;
#line 166 "Skein.xs"
		Skein_512_Ctxt_t *dest;
#line 414 "Skein.c"
	Digest__Skein__512	RETVAL;

	if (sv_derived_from(ST(0), "Digest::Skein::512")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__512,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::512::clone",
			"ctx", "Digest::Skein::512");
#line 168 "Skein.xs"
		Newx(dest, 1, Skein_512_Ctxt_t);
		memcpy(dest, ctx, sizeof(*dest));
		RETVAL = dest;
#line 429 "Skein.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Digest::Skein::512", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Digest__Skein__512_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__512_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::512::new", "package, hashbitlen=512");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	package = ST(0);
	int	hashbitlen;
	Digest__Skein__512	RETVAL;

	if (items < 2)
	    hashbitlen = 512;
	else {
	    hashbitlen = (int)SvIV(ST(1));
	}
#line 179 "Skein.xs"
		if (hashbitlen > 512)
			croak("hashbitlen > 512");
		if (SvROK(package)) {	/* called as $digest->new or $digest->reset */
			IV tmp;
			Digest__Skein__512	ctx;
			if (! sv_derived_from(package, "Digest::Skein::512"))
				croak("meh.");
			tmp = SvIV((SV*)SvRV(package));
			ctx = INT2PTR(Digest__Skein__512, tmp);
			if ( Skein_512_Init( ctx, items==2 ? hashbitlen : ctx->h.hashBitLen ) != SUCCESS )
				croak("Init() failed");
			RETVAL = ctx;
		}
		else {
			Skein_512_Ctxt_t *ctx;
			Newx(ctx, 1, Skein_512_Ctxt_t);
			if ( Skein_512_Init(ctx, hashbitlen) != SUCCESS )
				croak("Init() failed");
			ST(0) = sv_newmortal();
			sv_setref_pv(ST(0), "Digest::Skein::512", (void*)ctx);
		}
		XSRETURN(1);
#line 483 "Skein.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__Skein__512_hashbitlen); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__512_hashbitlen)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::512::hashbitlen", "ctx");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Digest__Skein__512	ctx;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Digest::Skein::512")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__512,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::512::hashbitlen",
			"ctx", "Digest::Skein::512");
#line 206 "Skein.xs"
		RETVAL = ctx->h.hashBitLen;
#line 516 "Skein.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Digest__Skein__512_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__512_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::512::DESTROY", "ctx");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Digest__Skein__512	ctx;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__512,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Digest::Skein::512::DESTROY",
			"ctx");
#line 214 "Skein.xs"
		Safefree(ctx);
#line 547 "Skein.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Digest__Skein__512_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__512_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::512::add", "ctx, data, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Digest__Skein__512	ctx;
	const u08b_t *	data;
	Digest__Skein__512	RETVAL;

	if (sv_derived_from(ST(0), "Digest::Skein::512")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__512,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::512::add",
			"ctx", "Digest::Skein::512");
#line 221 "Skein.xs"
	{
		int i;
		for (i=1; i<items; i++)
			if ( Skein_512_Update(ctx, (const u08b_t *)SvPV_nolen(ST(i)), SvCUR(ST(i))) != SUCCESS )
				croak("Update() failed");
		RETVAL = ctx;
	}
#line 585 "Skein.c"
    }
    XSRETURN(1);
}


XS(XS_Digest__Skein__512_digest); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__512_digest)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::512::digest", "ctx");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Digest__Skein__512	ctx;
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Digest::Skein::512")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__512,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::512::digest",
			"ctx", "Digest::Skein::512");
#line 233 "Skein.xs"
	{
		char hashval[512/8];
		int len = (ctx->h.hashBitLen + 7) >> 3;
		if ( Skein_512_Final(ctx, hashval) != SUCCESS )
			croak("final() failed");
		ST(0) = sv_2mortal(newSVpv(hashval, len));
		XSRETURN(1);
	}
#line 626 "Skein.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__Skein__1024_clone); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__1024_clone)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::1024::clone", "ctx");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Digest__Skein__1024	ctx;
#line 250 "Skein.xs"
		Skein1024_Ctxt_t *dest;
#line 648 "Skein.c"
	Digest__Skein__1024	RETVAL;

	if (sv_derived_from(ST(0), "Digest::Skein::1024")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__1024,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::1024::clone",
			"ctx", "Digest::Skein::1024");
#line 252 "Skein.xs"
		Newx(dest, 1, Skein1024_Ctxt_t);
		memcpy(dest, ctx, sizeof(*dest));
		RETVAL = dest;
#line 663 "Skein.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Digest::Skein::1024", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Digest__Skein__1024_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__1024_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::1024::new", "package, hashbitlen=1024");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	package = ST(0);
	int	hashbitlen;
	Digest__Skein__1024	RETVAL;

	if (items < 2)
	    hashbitlen = 1024;
	else {
	    hashbitlen = (int)SvIV(ST(1));
	}
#line 263 "Skein.xs"
		if (hashbitlen > 1024)
			croak("hashbitlen > 1024");
		if (SvROK(package)) {	/* called as $digest->new or $digest->reset */
			IV tmp;
			Digest__Skein__1024	ctx;
			if (! sv_derived_from(package, "Digest::Skein::1024"))
				croak("meh.");
			tmp = SvIV((SV*)SvRV(package));
			ctx = INT2PTR(Digest__Skein__1024, tmp);
			if ( Skein1024_Init( ctx, items==2 ? hashbitlen : ctx->h.hashBitLen ) != SUCCESS )
				croak("Init() failed");
			RETVAL = ctx;
		}
		else {
			Skein1024_Ctxt_t *ctx;
			Newx(ctx, 1, Skein1024_Ctxt_t);
			if ( Skein1024_Init(ctx, hashbitlen) != SUCCESS )
				croak("Init() failed");
			ST(0) = sv_newmortal();
			sv_setref_pv(ST(0), "Digest::Skein::1024", (void*)ctx);
		}
		XSRETURN(1);
#line 717 "Skein.c"
	PUTBACK;
	return;
    }
}


XS(XS_Digest__Skein__1024_hashbitlen); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__1024_hashbitlen)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::1024::hashbitlen", "ctx");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Digest__Skein__1024	ctx;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Digest::Skein::1024")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__1024,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::1024::hashbitlen",
			"ctx", "Digest::Skein::1024");
#line 290 "Skein.xs"
		RETVAL = ctx->h.hashBitLen;
#line 750 "Skein.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Digest__Skein__1024_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__1024_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::1024::DESTROY", "ctx");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Digest__Skein__1024	ctx;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__1024,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Digest::Skein::1024::DESTROY",
			"ctx");
#line 298 "Skein.xs"
		Safefree(ctx);
#line 781 "Skein.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Digest__Skein__1024_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__1024_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::1024::add", "ctx, data, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Digest__Skein__1024	ctx;
	const u08b_t *	data;
	Digest__Skein__1024	RETVAL;

	if (sv_derived_from(ST(0), "Digest::Skein::1024")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__1024,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::1024::add",
			"ctx", "Digest::Skein::1024");
#line 305 "Skein.xs"
	{
		int i;
		for (i=1; i<items; i++)
			if ( Skein1024_Update(ctx, (const u08b_t *)SvPV_nolen(ST(i)), SvCUR(ST(i))) != SUCCESS )
				croak("Update() failed");
		RETVAL = ctx;
	}
#line 819 "Skein.c"
    }
    XSRETURN(1);
}


XS(XS_Digest__Skein__1024_digest); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__Skein__1024_digest)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Digest::Skein::1024::digest", "ctx");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Digest__Skein__1024	ctx;
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Digest::Skein::1024")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(Digest__Skein__1024,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Digest::Skein::1024::digest",
			"ctx", "Digest::Skein::1024");
#line 317 "Skein.xs"
	{
		char hashval[1024/8];
		int len = (ctx->h.hashBitLen + 7) >> 3;
		if ( Skein1024_Final(ctx, hashval) != SUCCESS )
			croak("final() failed");
		ST(0) = sv_2mortal(newSVpv(hashval, len));
		XSRETURN(1);
	}
#line 860 "Skein.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Digest__Skein); /* prototype to pass -Wmissing-prototypes */
XS(boot_Digest__Skein)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXSproto("Digest::Skein::Skein", XS_Digest__Skein_Skein, file, "$$");
        newXSproto("Digest::Skein::skein_256", XS_Digest__Skein_skein_256, file, "$");
        newXSproto("Digest::Skein::skein_512", XS_Digest__Skein_skein_512, file, "$");
        newXSproto("Digest::Skein::skein_1024", XS_Digest__Skein_skein_1024, file, "$");
        newXSproto("Digest::Skein::256::clone", XS_Digest__Skein__256_clone, file, "$");
        newXSproto("Digest::Skein::256::new", XS_Digest__Skein__256_new, file, "$;$");
        newXSproto("Digest::Skein::256::hashbitlen", XS_Digest__Skein__256_hashbitlen, file, "$");
        newXSproto("Digest::Skein::256::DESTROY", XS_Digest__Skein__256_DESTROY, file, "$");
        newXSproto("Digest::Skein::256::add", XS_Digest__Skein__256_add, file, "$$;@");
        newXSproto("Digest::Skein::256::digest", XS_Digest__Skein__256_digest, file, "$");
        newXSproto("Digest::Skein::512::clone", XS_Digest__Skein__512_clone, file, "$");
        newXSproto("Digest::Skein::512::new", XS_Digest__Skein__512_new, file, "$;$");
        newXSproto("Digest::Skein::512::hashbitlen", XS_Digest__Skein__512_hashbitlen, file, "$");
        newXSproto("Digest::Skein::512::DESTROY", XS_Digest__Skein__512_DESTROY, file, "$");
        newXSproto("Digest::Skein::512::add", XS_Digest__Skein__512_add, file, "$$;@");
        newXSproto("Digest::Skein::512::digest", XS_Digest__Skein__512_digest, file, "$");
        newXSproto("Digest::Skein::1024::clone", XS_Digest__Skein__1024_clone, file, "$");
        newXSproto("Digest::Skein::1024::new", XS_Digest__Skein__1024_new, file, "$;$");
        newXSproto("Digest::Skein::1024::hashbitlen", XS_Digest__Skein__1024_hashbitlen, file, "$");
        newXSproto("Digest::Skein::1024::DESTROY", XS_Digest__Skein__1024_DESTROY, file, "$");
        newXSproto("Digest::Skein::1024::add", XS_Digest__Skein__1024_add, file, "$$;@");
        newXSproto("Digest::Skein::1024::digest", XS_Digest__Skein__1024_digest, file, "$");
    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

